// BonTestView.cpp : t@C
//

#include "stdafx.h"
#include "BonTest.h"
#include "BonTestView.h"


// CBonTestView

IMPLEMENT_DYNAMIC(CBonTestView, CWnd)

CBonTestView::CBonTestView() : m_eg( NULL )
{
	m_csPos.RegisterKey(CONFSECT_GENERAL, TEXT("ViewPos"), TEXT("-1,-1,-1,-1"));
}

CBonTestView::~CBonTestView()
{
}

void CBonTestView::SetEngine( CDtvEngine* p )
{
	m_eg = p;
}

BEGIN_MESSAGE_MAP(CBonTestView, CWnd)
	ON_WM_SIZING()
	ON_WM_LBUTTONDOWN()
	ON_WM_DESTROY()
	ON_MESSAGE( WM_EXITSIZEMOVE, OnExitSizeMove )
END_MESSAGE_MAP()

LRESULT CBonTestView::OnExitSizeMove( WPARAM wParam, LPARAM lParam )
{
	if( m_eg ){
		RECT rc;
		GetClientRect( &rc );
		m_eg->SetViewSize( &rc );
	}
	return( 0 );
}

void CBonTestView::OnSizing(UINT fwSide, LPRECT pRect)
{

	switch( fwSide ){
	case WMSZ_TOP: case WMSZ_BOTTOM:

		pRect->right = pRect->left + ((pRect->bottom - pRect->top) * 16 / 9);
		break;

	default:

		pRect->bottom = pRect->top + ((pRect->right - pRect->left) * 9 / 16);
		break;

	}

}

void CBonTestView::OnLButtonDown(UINT nFlags, CPoint point)
{
	PostMessage( WM_SYSCOMMAND, SC_MOVE | 2, MAKELPARAM(point.x,point.y) );
	CWnd::OnLButtonDown(nFlags, point);
}

void CBonTestView::OnDestroy()
{
	RECT rc;
	GetWindowRect( &rc );
	m_csPos.Format( _T("%d,%d,%d,%d"), rc.left, rc.top, rc.right - rc.left, rc.bottom - rc.top );
	PostQuitMessage( 0 );
}

BOOL CBonTestView::PreCreateWindow(CREATESTRUCT& cs)
{

	int x, y, cx, cy;
	_stscanf_s( m_csPos, _T("%d,%d,%d,%d"), &x, &y, &cx, &cy );
	if( x != -1 && y != -1 && cx != -1 && cy != -1 ){
		cs.x = x;
		cs.y = y;
		cs.cx = cx;
		cs.cy = cy;
	}

	return CWnd::PreCreateWindow(cs);
}
